// This source code is provided "as-is" and without any
// warranty of any kind, either express or implied.
//
// This code is placed in the public domain and may be
// freely modified or distributed as required.


import java.net.URL;
import java.sql.*;
import jdbc.idbDriver;
import java.io.FileInputStream;
import java.io.DataInputStream;
import java.util.StringTokenizer;

class commsql {

	public static void main (String args[]) {

		String url   = "jdbc:idb=sample.prp";

		try {

			// Uncomment the following if you want to enable driver-manager logging

			// java.sql.DriverManager.setLogStream(java.lang.System.out);

			idbDriver idb1=new idbDriver();

			Class idbClass=Class.forName ("jdbc.idbDriver");
			System.out.println ("Enter the url for the database");
			byte[] inBytes = new byte[512];
			System.in.read (inBytes);
			url = new String (inBytes);
			url = url.trim();
			Connection con = DriverManager.getConnection (url);
			
			// Get the DatabaseMetaData object and display
			// some information about the connection

			DatabaseMetaData dma = con.getMetaData ();

			System.out.println("\nConnected to " + dma.getURL());
			System.out.println("Driver   " + dma.getDriverName());
			System.out.println("Version  " + dma.getDriverVersion());
			System.out.println("");

			// Create a Statement object so we can submit
			// SQL statements to the driver

			Statement stmt = con.createStatement ();

			while (true) {
				System.out.println ("Enter SQL string, or . to exit");
				inBytes = new byte[512];
				System.in.read (inBytes);
				String SQLstr = new String (inBytes);
				SQLstr = SQLstr.trim();
				if (SQLstr.startsWith(".")) break;
				try {
					if (stmt.execute(SQLstr)) {
						// Result set available
						ResultSet rs = stmt.getResultSet();
						dispResultSet (rs);
						rs.close();
					} // if
				} catch (SQLException e) {
					e.printStackTrace ();
				} // try-catch
			} // while

			// Close the statement

			stmt.close();

			// Close the connection

			con.close();
		}
		catch (Exception ex) {
			ex.printStackTrace ();
		}
	}

	//-------------------------------------------------------------------
	// dispResultSet
	// Displays all columns and rows in the given result set
	//-------------------------------------------------------------------

	private static void dispResultSet (ResultSet rs)
		throws SQLException
	{
		int i;

		ResultSetMetaData rsmd = rs.getMetaData ();
		int numCols = rsmd.getColumnCount ();

		for (i=1; i<=numCols; i++) {
			if (i > 1) System.out.print(",");
			System.out.print(rsmd.getColumnLabel(i));
		}
		System.out.println("");
		
		while (rs.next ()) {

			for (i=1; i<=numCols; i++) {
				if (i > 1) System.out.print(",");
				System.out.print(rs.getString(i));
			}
			System.out.println("");

		}
	}
}
