import java.applet.*;
import java.awt.*;
import java.sql.*;
import jdbc.*;

public class JDBCAppl extends Applet {

	Connection			con;					// the database connection
	Label				urlLabel;				// label set to URL:
	public TextField	urlText;				// holds the current URL
	Button				connectButton;			// used to start a database connection
	Label				sqlLabel;				// holds the SQL: prompt
	public TextField	sqlText;				// holds the current SQL statement
	Button				submitButton;			// used to submit the SQL
	Label				tableLabel;				// holds the Tables label
	Label				outputLabel;			// holds the Output label
	List				tableList;				// holds list of tables
	public List			rowList;				// list of rows selected
	Label				statusLabel;			// show operational status
	Button				disconnectButton;		// used to disconnect
	Button				browseButton;			// used to browse for a url
	FileDialog			urlBrowse;				// the file dialog used to browse
	public TextArea		displayText;			// used to show full contents of selected row

	public void init () {
		try {
			Class idbClass=Class.forName ("jdbc.idbDriver");

			// create the components for the applet
			urlLabel = new Label ("URL:");
			urlText = new TextField	("jdbc:idb:c:\\Petes\\java\\Instant\\JDBCAppl\\Relative.prp");
			connectButton = new Button ("Connect");
			sqlLabel = new Label ("SQL:");
			sqlText= new TextField ("SELECT * FROM relative$db$tables");
			submitButton = new Button ("Submit");
			tableLabel = new Label ("Tables");
			outputLabel = new Label ("Results");
			tableList = new List ();
			rowList = new List();
			statusLabel = new Label ("Enter a URL and click on Connect");
			disconnectButton = new Button ("Disconnect");
			browseButton = new Button ("Browse");
			displayText = new TextArea(4,40);

			// overall layout is 3 panels - top, center and bottom
			Panel top = new Panel ();						// top part of applet
			Panel center = new Panel ();					// center part of applet
			setLayout (new BorderLayout(5,5));				// overall layout is a NSEWC one
			add ("North", top);
			add ("Center", center);
			add ("South", displayText);
			
			// set the top panel - consists of three more horizontally arranged panels
			top.setLayout (new BorderLayout(5, 5));			// give it distinct center
			Panel topLeft = new Panel ();					// holds the prompt labels
			Panel topCenter = new Panel ();					// holds the text fields
			Panel topRight = new Panel ();					// holds the buttons
			top.add ("West", topLeft);
			top.add ("Center", topCenter);
			top.add ("East", topRight);

			// Each of the top panels has a 2 rows x 1 col grid (2 for right panel)
			topLeft.setLayout (new GridLayout (2,1,5,5));
			topCenter.setLayout (new GridLayout (2,1,5,5));
			topRight.setLayout (new GridLayout (2,2,5,5));

			// finally - add all the top components
			topLeft.add (urlLabel);
			topLeft.add (sqlLabel);
			topCenter.add (urlText);
			topCenter.add (sqlText);
			topRight.add (connectButton);
			topRight.add (browseButton);
			topRight.add (submitButton);
			topRight.add (disconnectButton);

			// Center panel consists of two more horizontally arranged panels
			center.setLayout (new BorderLayout(5, 5));		// give it distinct center
			Panel centerLeft = new Panel ();				// holds the tables
			Panel centerCenter = new Panel ();				// holds the results
			center.add ("West", centerLeft);
			center.add ("Center", centerCenter);

			// Each of the center panels has a north and a center
			centerLeft.setLayout (new BorderLayout (5,5));
			centerCenter.setLayout (new BorderLayout (5,5));

			// finally add the center components
			centerLeft.add ("North", tableLabel);
			centerCenter.add ("North", outputLabel);
			centerLeft.add ("Center", tableList);
			centerCenter.add ("Center", rowList);
			centerCenter.add ("South", statusLabel);

			String[] propNames = {"java.version","java.vendor","java.vendor.url",
				"java.home","java.class.version","java.class.path",
				"os.name","os.arch","os.version","file.separator",
				"path.separator","line.separator","user.name",
				"user.home","user.dir"};

			StringBuffer rowEntry = new StringBuffer (500);
			for (int i=0; i<propNames.length; i++) {
				rowEntry.setLength(0);						// clear down buffer
				rowEntry.append (propNames[i]);				// set prop name
				rowEntry.append ('=');
				try {
					rowEntry.append (System.getProperty (propNames[i]));
				} catch (Exception e) {
					rowEntry.append (e.toString());
				} // try-catch
				rowList.addItem (rowEntry.toString());
			} // for
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	} // init

	/**
	 *
	 */
	private String addResultstoList (ResultSet rs, List ls, String colName) {
		StringBuffer curRow = new StringBuffer (500);		// create a bug string buffer

		try {
			ls.clear();										// clear out the list

			ResultSetMetaData rsmd = rs.getMetaData ();		// get results set info
			int numCols = rsmd.getColumnCount ();			// get number of columns

			while (rs.next ()) {							// while more rows
				curRow.setLength (0);						// clear out the buffer
				for (int i=1; i<=numCols; i++) {			// for each column
					if (colName != null) {					// if only one col reqd
						if (!rsmd.getColumnLabel(i).equalsIgnoreCase(colName))
							continue;
					} // if
					if (curRow.length() > 0) curRow.append(",");// check for later columns
					curRow.append(rs.getString(i));			// add to cur row
				}
				ls.addItem (curRow.toString());				// add row to list
			}

			curRow.setLength (0);							// clear out the buffer
			for (int i=1; i<=numCols; i++) {				// for each column header
				if (curRow.length() > 0) curRow.append(",");// check for comma to separate
				curRow.append(rsmd.getColumnLabel(i));		// and add new column header
			}
			
		} catch (Exception e) {
			statusLabel.setText (e.toString());
			e.printStackTrace();
		} // try-catch
		return curRow.toString();							// return columns headers
	} // method addResultstoList


	/**
	 *
	 */
	public boolean action (Event evt, Object what) {
		try {
			if (evt.target==submitButton) {					// check for submit SQL
				Statement stmt = con.createStatement ();
				if (stmt.execute(sqlText.getText())) {
					// Result set available
					ResultSet rs = stmt.getResultSet();
					String colNames = addResultstoList (rs, rowList, null);
					outputLabel.setText (colNames);
					rs.close();
				} // if
				stmt.close();
				return true;
			} else if (evt.target==connectButton) {			// check for connect
				statusLabel.setText ("Connecting...");
				con = DriverManager.getConnection (urlText.getText());
				DatabaseMetaData dbmd = con.getMetaData();
				statusLabel.setText ("Connected to "
					+dbmd.getDatabaseProductName()+" "
					+dbmd.getDatabaseProductVersion());
				ResultSet rs = dbmd.getTables (null,null,"%",null);
				addResultstoList (rs, tableList, "TABLE_NAME");
				rs.close();
				return true;
			} else if (evt.target==disconnectButton) {		// check for disconnect
				if (con != null) con.close();
				con=null;
				statusLabel.setText ("Disconnected");
			} else if (evt.target==browseButton) {			// check for url browse
				if (urlBrowse==null) {						// if not created yet
					urlBrowse=new FileDialog (
						(Frame)getParent(), "Select a database", FileDialog.LOAD);
				} // if
				urlBrowse.show();
				urlText.setText ("jdbc:idb:"
					+urlBrowse.getDirectory()+urlBrowse.getFile());
			} // if-else
		} catch (Exception e) {
			statusLabel.setText (e.toString());
			e.printStackTrace();
		} // try-catch
		return false;
	} // method action

	/**
	 * Handles the list selection event.
	 */
	public boolean handleEvent (Event evt) {
		if (evt.target == tableList &&						// if the table list
			evt.id == Event.LIST_SELECT) {					// and a select event
				sqlText.setText("SELECT * FROM "+tableList.getSelectedItem());
			return true;
		} // if
		if (evt.target == rowList &&						// if the row list
			evt.id == Event.LIST_SELECT) {					// and a select event
				displayText.appendText("\n"+rowList.getSelectedItem());
			return true;
		} // if
		return super.handleEvent (evt);						// let Applet handle it
	} // method handleEvent


	/**
	 *
	 */
	public void destroy () {
		try {
			if (con != null) con.close();
		} catch (Exception e) {
			statusLabel.setText (e.toString());
			e.printStackTrace();
		} // try-catch
	} // method destroy


} // Class JDBCAppl

