//
// Msql client library for JAVA
// Copyright (C) 1995 Darryl Collins <darryl@minmet.uq.oz.au>
// This software is provided "as is" without any expressed or implied warranty.
//
// This package implements a client for the mSQL server designed and
// implemented by David Hughes <bambi@hughes.com.au>
//
// Revision 1.2  1997/02/25
//

package msql;

import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;

/**
 * Storage for a single row of a table.  MsqlData is a set of MsqlRow structures.
 */
class MsqlRow {

	private int nCols;
	private String strData[];

/**
 * Constructor - accepts number of cols and a raw row string as arguments
 */
        public MsqlRow(int n, String s) {

                int i,j,k,l;

		nCols = n;
                strData = new String[nCols];

		for(i=j=0; i<nCols; i++) {
			k = s.indexOf(':',j);
			if(k == -1)
				k = s.length();
			l = Integer.parseInt(s.substring(j,k));

			if(l == -2) {
                                strData[i] = null;
				j = k+1;
			} else {
                                strData[i] = new String(s.substring(k+1,k+1+l));
				j = k+l+1;
			}
		}
	}

/**
 * Constructor - duplicates another row
 */
	public MsqlRow(MsqlRow r) {
		
		nCols = r.nCols;
		strData = new String[nCols];
	
		for(int i=0; i<nCols; i++)
			if(r.strData[i] != null)
				strData[i] = new String(r.strData[i]);
	}

/**
 * Returns contents as array of strings 
 */
        protected String [] rowData() {

		return strData;
	}


/**
 * Returns number of cols
 */
	public int NumFields() {
		
		return nCols;
	}
}

