import java.awt.*; 
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
 
public class Client extends Applet 
                 implements Runnable, ActionListener 
{ 
  Label Status; 
  DrawCanvas c; 
  Thread thread; 
  boolean auto, slideShow=false;
  
  public void init() { 
    setLayout(new BorderLayout()); 
    
    setBackground(Color.gray); 
    setForeground(Color.black); 
    
    Panel w=new Panel(); 
    w.setLayout(new GridLayout(10, 0)); 

    Button b;
    w.add(b=new Button("Update")); 
    b.addActionListener(this);			// the applet is one of the listeners
    w.add(b=new Button("Previous"));
    b.addActionListener(this);			// the applet is one of the listeners
    w.add(b=new Button("Next"));
    b.addActionListener(this);			// the applet is one of the listeners
    w.add(b=new Button("Auto Show"));
    b.addActionListener(this);			// the applet is one of the listeners
    
    add(BorderLayout.WEST, w); 
    
    Status=new Label("Status Line"); 
    add(BorderLayout.SOUTH,Status); 
    
    c=new DrawCanvas(this); 
    c.setBackground(Color.blue); 
    add(BorderLayout.CENTER, c);
    
    if (getParameter("autoStart").equals("yes")) auto=true;
    else auto=false;
  } 
  
  public void start () {
    
    if(thread == null) {
      thread = new Thread(this);
    }
    thread.start();
  }
  
  public void run() {
    while(thread != null) {
      getData();
      try { Thread.sleep(5000); }
      catch (InterruptedException e) {}
    }
  }
  
  public void stop() {
    if(thread != null) {
      thread.stop();
    }
  }
  
  public void getData() {
    if (auto) {
      c.showNextSlide();
    } else {
      Status.setText("Getting the slides..."); 
      c.getData();
      repaint();
    }
  }
  
  public void paint(Graphics g) { 
    c.paint(g); 
  } 
  
  public void actionPerformed(ActionEvent e) {
    String s = e.getActionCommand();
    Button b=(Button)e.getSource();

    Status.setText(s);
    auto = false; 
    if (s.equals("Update")) {
      thread.resume();
      slideShow=false;
      auto=false;
    } else if (s.equals("Previous")) {
      if(!slideShow) thread.suspend();
      slideShow=true;
      c.showPrevSlide();
    } else if (s.equals("Next")) {
      if(!slideShow) thread.suspend();
      slideShow=true;
      c.showNextSlide();
    } else if (s.equals("Auto Show")) {
      auto = true;
      slideShow=false;
      thread.resume();
    }
    
  }
}


class DrawCanvas extends Canvas {
  
  Client parent;
  String curMode="Rect";
  mPoint curObj;
  public boolean fill=true;
  mSlide currentSlide=null;
  Vector slides=new Vector(10, 5);
  
  String    SlideInfo = "Slide1";
  Hashtable colors;
  String    currentColor = "red";
  String    fillColor = "black";
  String    backgroundColor="blue";
  Font      currentFont;
  boolean   interlace=false;
  
  mText     lasttext=null;
  String    script, section, session, title, instructor;
  URL       baseUrl;
  
  public DrawCanvas(Client _parent) {
    
    super();
    parent = _parent;
    setBackground(Color.blue);
    setForeground(Color.yellow);
    
    baseUrl= parent.getDocumentBase();
    script = parent.getParameter("javaTransferScript");
    section= parent.getParameter("scriptSection");
    session= parent.getParameter("lectureCode");
    
    colors=new Hashtable();
    colors.put("black", 	Color.black);
    colors.put("blue",  	Color.blue);
    colors.put("cyan", 	Color.cyan);
    colors.put("darkGray", 	Color.darkGray);
    colors.put("gray", 	Color.gray);
    colors.put("green", 	Color.green);
    colors.put("lightGray",	Color.lightGray);
    colors.put("magenta", 	Color.magenta);
    colors.put("orange", 	Color.orange);
    colors.put("pink", 	Color.pink);
    colors.put("red", 	Color.red);
    colors.put("white", 	Color.white);
    colors.put("yellow", 	Color.yellow);
    
    currentFont = new Font("Helvetica", Font.PLAIN, 12);
    
  } 
  
  public void paint(Graphics g) {
    
    if (currentSlide != null) {
      g.setColor(getHashedColor(currentSlide.bgColor));
      g.fillRect(0, 0, getSize().width, getSize().height);
      mPoint p;
      for(Enumeration e=currentSlide.elements(); e.hasMoreElements() ;) {
	p= (mPoint)e.nextElement();
	if (p != null) p.draw(g);
      }
    }
    
  }
  
  
  public void getData() {
    
    String strReturn = "", strData = "";  
    Socket sckS = null;
    try {
      sckS = new Socket(baseUrl.getHost(), baseUrl.getPort());
      
      DataOutputStream os
	= new DataOutputStream(sckS.getOutputStream());
      BufferedReader is = new BufferedReader(new InputStreamReader(sckS.getInputStream()));
      //DataInputStream is = new DataInputStream(sckS.getInputStream());
      
      strData = "section=" + section + "&code=" + session;
      
      os.writeBytes("POST " + script
		    + " HTTP/1.0\r\n"
		    + "Content-type: application/octet-stream\r\n"
		    + "Content-length: "
                    + strData.length() + "\r\n\r\n");
      os.writeBytes(strData);
      
      String line="";
      // get rid of the header.
      while (((line = is.readLine()) != null)
	     && !(line.startsWith("Content-type:")));
      
      // save the information
      while ((line = is.readLine()) != null) {
	strReturn += line + "\n";
      }
      
      is.close();
      os.close();
      
    } 
    catch (Exception e) {
      
      if (sckS != null) {
	try { sckS.close(); }   
	catch (IOException ex) {}
	
      }
    }
    
    slides.removeAllElements();
    
    StringTokenizer st=new StringTokenizer(strReturn, "\n");
    while(st.hasMoreElements()) 
      addObject(st.nextToken());
    //        return strReturn;
    
  }
  
  public void addObject(String s) {		
    
    StringTokenizer st = new StringTokenizer(s);
    String token;
    
    while (st.hasMoreTokens()) {
      
      token = st.nextToken();
      if (token.equals("Session")) {        /* the lecture code */
	//session=st.nextToken();
      } else if (token.equals("Error")) {   /* an error occured */
	//while (st.hasMoreElements()) s += st.nextToken() +" ";
      } else if (token.equals("Title")) {   /* the lecture's title */
	while (st.hasMoreElements()) title += st.nextToken() +" ";
      } else if (token.equals("Instructor")) { /* the instructor's name */
	while (st.hasMoreElements()) instructor += st.nextToken() +" ";
      } else if (token.equals("NewSlide")) {
	currentSlide=new mSlide(st.nextToken(),          /*slide name*/
				Integer.parseInt(st.nextToken()),  /*width*/
				Integer.parseInt(st.nextToken()),  /*height*/
				st.nextToken());           /*bgcolor*/
      } else if (token.equals("EndOf")) {
	slides.addElement(currentSlide);
	repaint();
      } else if (token.equals("Color"))
	colors.put(st.nextToken(), 
		   new Color(Integer.parseInt(st.nextToken()),  /*red*/
			     Integer.parseInt(st.nextToken()),  /*green*/
			     Integer.parseInt(st.nextToken())));/*blue*/
      else if (token.equals("fillRect")) {
	mPoint p = new mRectangle(this,
				  Integer.parseInt(st.nextToken()), /*x*/
				  Integer.parseInt(st.nextToken()), /*y*/
				  Integer.parseInt(st.nextToken()), /*x2*/
				  Integer.parseInt(st.nextToken()), /*y2*/
				  st.nextToken(), st.nextToken());  /*color,fillcolor*/
	p.setFill(true);
	currentSlide.addElement(p);
      } else if (token.equals("drawRect")) {
	mPoint p = new mRectangle(this,
				  Integer.parseInt(st.nextToken()), /*x*/
				  Integer.parseInt(st.nextToken()), /*y*/
				  Integer.parseInt(st.nextToken()), /*x2*/
				  Integer.parseInt(st.nextToken()), /*y2*/
				  st.nextToken(), "black");  /*color,fillcolor*/
	p.setFill(false);
	currentSlide.addElement(p);
      } else if (token.equals("fillRoundRect")) {
	mPoint p = new mRound(this,
			      Integer.parseInt(st.nextToken()), /*x*/
			      Integer.parseInt(st.nextToken()), /*y*/
			      Integer.parseInt(st.nextToken()), /*x2*/
			      Integer.parseInt(st.nextToken()), /*y2*/
			      st.nextToken(), st.nextToken());  /*color,fillcolor*/
	p.setFill(true);
	currentSlide.addElement(p);
      } else if (token.equals("drawRoundRect")) {
	mPoint p = new mRound(this,
			      Integer.parseInt(st.nextToken()), /*x*/
			      Integer.parseInt(st.nextToken()), /*y*/
			      Integer.parseInt(st.nextToken()), /*x2*/
			      Integer.parseInt(st.nextToken()), /*y2*/
			      st.nextToken(), "black");  /*color,fillcolor*/
	p.setFill(false);
	currentSlide.addElement(p);
      } else if (token.equals("drawLine")) {
	mPoint p = new mLine(this,
			     Integer.parseInt(st.nextToken()), /*x*/
			     Integer.parseInt(st.nextToken()), /*y*/
			     Integer.parseInt(st.nextToken()), /*x2*/
			     Integer.parseInt(st.nextToken()), /*y2*/
			     st.nextToken(), "black");  /*color,fillcolor*/
	currentSlide.addElement(p);
      } else if (token.equals("drawOval")) {
	mPoint p = new mCircle(this,
			       Integer.parseInt(st.nextToken()), /*x*/
			       Integer.parseInt(st.nextToken()), /*y*/
			       Integer.parseInt(st.nextToken()), /*x2*/
			       Integer.parseInt(st.nextToken()), /*y2*/
			       st.nextToken(), "black");  /*color,fillcolor*/
	p.setFill(false);
	currentSlide.addElement(p);
      } else if (token.equals("fillOval")) {
	mPoint p = new mCircle(this,
			       Integer.parseInt(st.nextToken()), /*x*/
			       Integer.parseInt(st.nextToken()), /*y*/
			       Integer.parseInt(st.nextToken()), /*x2*/
			       Integer.parseInt(st.nextToken()), /*y2*/
			       st.nextToken(), st.nextToken());  /*color,fillcolor*/
	p.setFill(true);
	currentSlide.addElement(p);
      } else if (token.equals("setFont")) {
	currentFont = new Font(st.nextToken(), /*font name*/
			       (st.nextToken().equals("bold") ? Font.BOLD : 0)+    /*bold*/
			       (st.nextToken().equals("italic") ? Font.ITALIC : 0),/*italic*/
			       Integer.parseInt(st.nextToken())); /*size*/
      } else if (token.equals("drawString")) {
	mText p = new mText(this,
			    Integer.parseInt(st.nextToken()), /*x*/
			    Integer.parseInt(st.nextToken()), /*y*/
			    st.nextToken());                   /*color*/
	s="";
	while (st.hasMoreElements()) s += st.nextToken() +" ";
	p.setData(s, currentFont); /*string data*/
	currentSlide.addElement(p);
      }
      
      
    } // while
  }
  
  public Color getHashedColor(String keyColor) {
    return (Color)colors.get(keyColor);
  }
  
  public void showPrevSlide() {
    
    if (currentSlide != null) {
      int slideno=slides.indexOf(currentSlide);
      if (slideno > 0) 
	currentSlide = (mSlide) slides.elementAt(slideno-1);
      else currentSlide = (mSlide) slides.lastElement();
    }
    repaint();
  }
  
  public void showNextSlide() {
    
    if (currentSlide != null) {
      int slideno=slides.indexOf(currentSlide);
      if (slideno < slides.size()-1) 
	currentSlide = (mSlide) slides.elementAt(slideno+1);
      else currentSlide = (mSlide) slides.firstElement();
    }
    repaint();
  }
  
}

class mSlide extends Vector {
  
  String slideName;
  int width, height;
  String bgColor;
  
  public mSlide(String name, int w, int h, String bgC) {
    super(15, 10);
    slideName = name;
    width=w;
    height=h;
    bgColor=bgC;
  }
  
  public String makeString() {
    String result= "NewSlide "+slideName+" "+
      String.valueOf(width)+" "+String.valueOf(height)+" "+bgColor+"\n";
    
    for(Enumeration e=elements(); e.hasMoreElements() ;) {
      result += ((mPoint)e.nextElement()).toString() + "\n";
    }
    
    result += "EndOf "+slideName+"\n";
    return result;
  }
}


class mPoint {
  
  DrawCanvas parent;
  int x,y,x2,y2;
  boolean fill=false;
  String color, fillcolor;
  
  public mPoint( DrawCanvas _parent, 
		 int _x, int _y, int _x2, int _y2, 
		 String _color, String _fillcolor) {
    
    parent=_parent;
    x=_x;
    y=_y;
    x2=_x2;
    y2=_y2;
    color=_color;
    fillcolor=_fillcolor;
  };
  
  public void draw(Graphics g) {
    g.setColor(parent.getHashedColor(color));
    g.drawRect(x, y, x2-x, y2-y);
  }
  
  public void setFill(boolean _fill) {
    fill=_fill;
  }
  
  public boolean isIn(int _x, int _y) {
    if( x==_x && y == _y) return true;
    return false;
  }
  
  public void setEnds(int _x, int _y) {
    x2=_x;
    y2=_y;
  }
  
  public String toString(String SlideInfo) {
    return SlideInfo + " drawLine " +  
      String.valueOf(x) + " " + String.valueOf(y) + " " +
      String.valueOf(x) + " " + String.valueOf(y) + " " + color; 
  }
}

class mRectangle extends mPoint {
  
  public mRectangle( DrawCanvas _parent, 
		     int _x, int _y, int _x2, int _y2, 
		     String _color, String _fillcolor) {
    
    super(_parent, _x, _y, _x2, _y2, _color, _fillcolor);
  }
  
  public void draw(Graphics g) {
    if (fill) {
      g.setColor(parent.getHashedColor(fillcolor));
      g.fillRect(x, y, x2-x, y2-y);
    }
    g.setColor(parent.getHashedColor(color));
    g.drawRect(x, y, x2-x, y2-y);
  }
  
  public boolean isIn(int _x, int _y) {
    Rectangle r=new Rectangle(x, y, x2-x, y2-y);
    return r.contains(_x, _y);
  }
 
  public String toString(String SlideInfo) {
    String s = SlideInfo + " drawRect "; 
    String coor = String.valueOf(x) + " " + String.valueOf(y) + " " +
      String.valueOf(x2) + " " + String.valueOf(y2) + " ";
    
    if (fill) s = SlideInfo +" fillRect " + coor + fillcolor + "\n" + s;
    return  s + coor + color;
  }
  
}

class mRound extends mPoint {
  
  public mRound( DrawCanvas _parent, 
		 int _x, int _y, int _x2, int _y2, 
		 String _color, String _fillcolor) {
    
    super(_parent, _x, _y, _x2, _y2, _color, _fillcolor);
  }
  
  public void draw(Graphics g) {
    if (fill) {
      g.setColor(parent.getHashedColor(fillcolor));
      g.fillRoundRect(x, y, x2-x, y2-y, 100, 50);
    }
    g.setColor(parent.getHashedColor(color));
    g.drawRoundRect(x, y, x2-x, y2-y, 100, 50);
  }
  
  public boolean isIn(int _x, int _y) {
    Rectangle r=new Rectangle(x, y, x2-x, y2-y);
    return r.contains(_x, _y);
  }
  
  public String toString(String SlideInfo) {
    String s = SlideInfo + " drawRoundRect "; 
    String coor = String.valueOf(x) + " " + String.valueOf(y) + " " +
      String.valueOf(x2) + " " + String.valueOf(y2) + " ";
    
    if (fill) s = SlideInfo +" fillRoundRect " + coor + fillcolor + "\n" + s;
    return  s + coor + color;
  }
  
}

class mLine extends mPoint {
  
  public mLine( DrawCanvas _parent, 
		int _x, int _y, int _x2, int _y2, 
		String _color, String _fillcolor) {
    
    super(_parent, _x, _y, _x2, _y2, _color, _fillcolor);
  }
  
  public void draw(Graphics g) {
    g.setColor(parent.getHashedColor(color));
    g.drawLine(x, y, x2, y2);
  }
  
  public String toString(String SlideInfo) {
    
    return  SlideInfo + " drawLine " +
      String.valueOf(x) + " " + String.valueOf(y) + " " +
      String.valueOf(x2) + " " + String.valueOf(y2) + " " + color;
  }
}

class mCircle extends mRectangle {
  
  public mCircle( DrawCanvas _parent, 
		  int _x, int _y, int _x2, int _y2, 
		  String _color, String _fillcolor) {
    
    super(_parent, _x, _y, _x2, _y2, _color, _fillcolor);
  }
  
  public void draw(Graphics g) {
    if (fill) {
      g.setColor(parent.getHashedColor(fillcolor));
      g.fillOval(x, y, x2-x, y2-y);
    }
    g.setColor(parent.getHashedColor(color));
    g.drawOval(x, y, x2-x, y2-y);
  }
  
  public String toString(String SlideInfo) {
    int w = x2 - x;
    int h = y2 - y;
    
    String s = SlideInfo + " drawArc "; 
    String coor = String.valueOf(x) + " " + String.valueOf(y) + " " +
      String.valueOf(w) + " " + String.valueOf(w) + " 0 360";
    
    if (fill) s = SlideInfo +" fillArc " + coor + fillcolor + "\n" + s;
    return  s + coor + color;
    
  }
}

class mText extends mPoint {
  
  String data;
  Font fontInfo;
  
  public mText( DrawCanvas _parent, 
		int _x, int _y, 
		String _color) {
    
    super(_parent, _x, _y, _x, _y, _color, _color);
    data = "";
    fontInfo = null;
    
  }
  
  public void setData(String _data, Font _font) {
    data=_data;
    fontInfo=_font;
  }
  
  public void draw(Graphics g) {
    
    g.setFont(fontInfo);
    g.setColor(parent.getHashedColor(color));
    g.drawString(data, x, y);
    
  }
  
  public String toString(String SlideInfo) {
    String fontstyle=fontInfo.getName() + " " +
      (fontInfo.isBold() ? "bold" : "not-bold") + " " +
      (fontInfo.isItalic() ? "italic" : "not-italic") + " " +
      String.valueOf(fontInfo.getSize())  ; 
    
    return  SlideInfo + " setFont " + fontstyle + "\n" +
      SlideInfo + " drawString " +
      "\"" + data + "\" " +
      String.valueOf(x) + " " + String.valueOf(y) + " " + color ;
  }
  
}

















































