// ***************************
//   Assignment #1 for cps606: Polynomial Class
//   File:       Polynomial.java (source code)
//   Author:     Jiangping Chen
//   Contact:    jchen06@syr.edu
// ****************************/
//  The Polynomial class can construct polynomial objects by
//  receiving parameters from outside and perform some mathematical
//  operations, such as addition, substraction and multiplication by
//  constant. It can also output its degree and string representation.
// ****************************


public class Polynomial
{
   		//instance variables
		private int degree;     //degree of the Polynomial
		private double coeff[]; //array store the coefficients, the lowest one in coeff[0]

		//////////////////////////////////////////////////////
		// Constructors
		//
		// for initializing instance variables degree and coeff
		// //////////////////////////////////////////////////
		/* constructor for two arguments.
		 * set degree and the array of double for coefficients
		 */
		public Polynomial (int n,double[] m)
		{
			degree = n;
			coeff=new double[degree+1];
			if (m.length ==degree+1)
			{	for(int a=0;a<m.length;a++)
			 		coeff[a]=m[a];
			}
		}

		/* constructor method for creating 0 polynomial
		 * degree is set to 0 and coefficient array has
		 * only one element whose value is 0
		 */
		public Polynomial ()
		{   degree = 0;
			coeff = new double[degree+1];
			coeff[0] = 0;
		}

		///////////////////////////////////////////////
		// addPo
		//
		// public Polynomial addPo(Polynomial po)
		//
		// argument:     	Polynomial po
		// return value: 	Polynomial
		// local variable: 	double[] tempcoeff
		//						for temporary store coefficients
		//					int tempdegree
		//						for temporary store degree
		//					Polynomial temp
		//						for temporary store polynomial and
		//						also to be a returned value
		//
		// the method add two polynomials by calling private method matharray
		// to calculate the coefficients and return the result.
		/////////////////////////////////////////////////////////
		public Polynomial addPo(Polynomial po)
		{
			// get the coefficient array by calling private method.
			double[] tempcoeff=matharray(coeff,po.coeff,1);
			//store degree for return polynomial
			int tempdegree=tempcoeff.length -1;
			Polynomial temp = new Polynomial (tempdegree, tempcoeff);
			return temp;
		}

		///////////////////////////////////////////////
		// subPo
		//
		// public Polynomial subPo(Polynomial po)
		//
		// argument:     	Polynomial po
		// return value: 	Polynomial
		// local variable: 	double[] tempcoeff
		//						for temporary store coefficients
		//					int tempdegree
		//						for temporary store degree
		//					Polynomial temp
		//						for temporary store polynomial and
		//						also to be a returned value
		//
		// the method will subtract Polynomial po by calling private
		// method matharray to calculate the coefficients and return
		// the result
		/////////////////////////////////////////////////////////
		public Polynomial subPo(Polynomial po)
		{
			// get the coefficient array by calling private method.
			double[] tempcoeff=matharray(coeff,po.coeff,2);
			//store degree for return polynomial
			int tempdegree=tempcoeff.length -1;
			Polynomial temp = new Polynomial (tempdegree, tempcoeff);
			return temp;
		}

		///////////////////////////////////////////////
		// multPo
		//
		// public Polynomial multPo(double c)
		//
		// argument:     	double c
		// return value: 	Polynomial
		// local variable: 	double[] tempcoeff
		//						for temporary store coefficients
		//					Polynomial temp
		//						for temporary store polynomial and
		//						also to be a returned value
		//
		// the method performs multiplication of a polynomial
		// by a constant and return the result
		/////////////////////////////////////////////////////////
		//
		public Polynomial multPo(double c)
		{	double[] tempcoeff=new double[coeff.length];
			for(int i=0; i<coeff.length; i++)
				tempcoeff[i]=c*coeff[i];
			Polynomial temp = new Polynomial (degree, tempcoeff);
			return temp;
		}

		/////////////////////////////////////////////////////////
		// toString
		//
		// public String toString()
		//
		// argument:     	none
		// return value: 	String
		// local variable: 	int j, z;
		//						use for loop process, store temporary
		//						integer value
		//					String str1,str2;
		//						for temporary store String and
		//						also str2 to be a returned value
		//
		// the method converts a polynomial to a printed representation.
		// A lot of situations should be considered. if the coefficient is
		// negative, we need to use () to include intermediate coefficient.
		// if the coefficient equals zero,then direct go to next item, etc.
		//////////////////////////////////////////////////////////
		public String toString()
		{
			int j=degree,z=1;
			String str1, str2="";
			if (j==0)		//when degree =0, return the only coefficient
			{ str1=Double.toString(coeff[0]);
			  return str1;}
			// add the coefficient and degree to a string
			for(int i=coeff.length-1; i>=0; i--)
			{
				if(coeff[i]!=0)       //only to nonzero coefficient make the tranformation
				{   if((z==1)&&(i!=coeff.length-1)) str2=str2 + " + ";
					if((coeff[i])<0)  //if coeff <0, use (coeff) expression
					{  str1="("+Double.toString(coeff[i])+")"; }
					else
					{  str1=Double.toString(coeff[i]);}   //transform double to string
				    if(j==0) {str2=str2+str1;        // if that is the last coeff, add directly
							z=0;}
				    else if(j==1) {str2=str2+str1+"x";}  //transform like ax
					else { str2=str2+str1+"x"+"**"+ Integer.toString(j);}
				}
				j--;
			}
			return str2;
		}

		///////////////////////////////////////////////////////
		// getDegree
		//
		// public int getDegree()
		//
		// argument:     	none
		// return value: 	int
		// local variable: 	none
		//
		// the method output the value of degree
		///////////////////////////////////////////////////////
		public int getDegree()
		{	return degree;}

		/////////////////////////////////////////////////////////
		// matharray
		//
		// private double[] matharray(double[] coeff1,double[] coeff2, int flag)
		//
		// argument:     	double[] coeff1, coeff2
		//						for computation
		//					int flag;
		//						to indicate what calculation: 1 for addition,
		//													2 for subtraction
		// return value: 	double[]
		// local variable: 	int i,j;
		//						store temporary integer value
		//					String str1,str2;
		//						for temporary store String and
		//						also str2 to be a returned value
		//					double temp[], temp1[], temp2[]
		//						for store temporary coefficients and also
		//						to be a returned array according
		//						to different situations
		// the method performs addition or subtraction of two double
		// arrays according to the flag parameter. It returns the result
		// after elimilating the zero top degree coefficients.
		/////////////////////////////////////////////////////////////
		private double[] matharray(double[] coeff1,double[] coeff2, int flag)
		{
			int i,j;
			double temp[];

			//copy the longer array into temp
			if(coeff1.length >= coeff2.length)
			{	temp=new double[coeff1.length];}
			else
			{	temp=new double[coeff2.length];}

			//add or sub common part of two arrays
			j=0;
			while ((j<coeff1.length)&&(j<coeff2.length))
			{
				if(flag==1){ temp[j]=coeff1[j]+coeff2[j];}
				else { temp[j]=coeff1[j]- coeff2[j];}
				j++;
			}
			// if coeff1 is shorter, copy remained in coeff2 to temp
			if(j==coeff1.length)
			{	if(flag==1)
				{	for(i=j;i<coeff2.length;i++)
						temp[i]=coeff2[i];}
				else
				{	for(i=j;i<coeff2.length;i++)
						temp[i]=(-1)*coeff2[i];}
			}
			// if coeff2 is shorter, copy remained in coeff1 to temp
			else if(j==coeff2.length)
			{	for(i=j;i<coeff1.length;i++)
						temp[i]= coeff1[i];
			}
			// check the top coefficient, create new array to stand for
			// the remaining part if the higher coefficients are zero
			for(i=temp.length-1;i>=0;i--)
			{    if (temp[i]!=0)
				 { 	if (i==temp.length-1) {return temp;}
				 	else
					{	double[] temp1=new double[i+1];
						for(j=0;j<=i;j++) temp1[j]=temp[j];
						return temp1;}
				 }
			}
			// if all the coefficients are zero,
			// return an array with one value of 0
			double[] temp2=new double[1];
			temp2[0]=0;
			return temp2;
		}
}
