//Title:        HSA Parents' Corner
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Ozgur Balsoy
//Company:
//Description:  Online Parental Access to the School Database

package hsa;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import hsa.db.database;
import hsa.db.students;
import hsa.db.dbHashtable;
import hsa.util.Log;
import hsa.util.Parser;

import java.util.Enumeration;

import java.sql.*;

public class login extends HttpServlet {
//Initialize global variables

  String user, password;

//Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    PrintWriter out = new PrintWriter (response.getOutputStream());

    try {

    // Get Authorization header
    String auth = request.getHeader("Authorization");

    // Do we allow that user?
    if (!allowUser(auth)) {
      // Not allowed, so report he's unauthorized
      Log.log("Not allowed, so report he's unauthorized.");
      response.setHeader("WWW-Authenticate", "BASIC realm=\"users\"");
      response.sendError(response.SC_UNAUTHORIZED);
      // Could offer to add him to the allowed user list
    }

    String template = getServletConfig().getInitParameter("docroot")+request.getPathInfo();

    //String id = request.getParameter("id").trim();
    String command = request.getParameter("command").trim();

    response.setContentType("text/html");
    out.println("<html>");
    out.println("<head><title>login</title></head>");
    out.println("<body><h1>Command: " + command + "</h1>");
    out.println("<p>User name:"+ request.getRemoteUser());
    out.println("<p>Template file: "+ template +"</p>");

      if( command.equals("login") )
      {
        Log.log("Template file: "+template);
        File f = new File(template);
        if(f.isFile()) {
          dbHashtable dbht = students.queryStudent( user );
          if(dbht.isReady())
            Parser.parseHtml(template, dbht, out);
        } else
          response.sendError(response.SC_NOT_FOUND);
      }
      else if( command.equals("all") )
      {
        Log.log("Template file: "+template);
        File f = new File(template);
        if(f.isFile()) {
          dbHashtable dbht = students.queryStudent( user );
          dbht.print(out);
        } else
          response.sendError(response.SC_NOT_FOUND);
      }
      else if ( command.equals("close") )
      {
        database.close();
        out.println("<p>close is successful</p>");
      }
      else if ( command.equals("students") )
      {
        students.queryStudents("id_number, l_name, f_name", "", "id_number", "id_number");
        //students.queryStudents(out, "*", "sex='M'", "id_number", "id_number");
        out.println("<p>students is successful</p>");
      }
      else if ( command.equals("sayhello") )
        out.println("<p>hello!</p>");
    } catch (Exception e) {
      out.println("<pre>");
      e.printStackTrace(out);
    }

    for(Enumeration e=request.getHeaderNames(); e.hasMoreElements(); )
    {
      String s = (String)e.nextElement();
      out.println(s + ": " + request.getHeader(s) + "<br>");
    }
    out.println("<p>Session id: "+ request.getRequestedSessionId() );
    out.println("<p>User name:"+ request.getRemoteUser());
    out.println("</body></html>");
    out.close();
  }

//Process the HTTP Post request
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    doPost( request, response );
  }

  //Get Servlet information
  public String getServletInfo() {
    return "hsa.login Information";
  }

    // This method checks the user information sent in the Authorization
  // header against the database of users maintained in the users Hashtable.
  protected boolean allowUser(String auth) throws Exception {
    if (auth == null) return false;  // no auth

    if (!auth.toUpperCase().startsWith("BASIC "))
      return false;  // we only do BASIC

    // Get encoded user and password, comes after "BASIC "
    String userpassEncoded = auth.substring(6);

    // Decode it, using any base 64 decoder
    sun.misc.BASE64Decoder dec = new sun.misc.BASE64Decoder();
    String userpassDecoded = new String(dec.decodeBuffer(userpassEncoded));

    // Check our user list to see if that user and password are "allowed"
    //if ("allowed".equals(users.get(userpassDecoded)))
    //  return true;
    //else
    //  return false;
    try {
      StringTokenizer st = new StringTokenizer( userpassDecoded, ":" );
      user = st.nextToken();
      password = st.nextToken();
    } catch(java.util.NoSuchElementException e) {
      return false;
    }
    return students.authorized( user, password );
  }

}

