
//Title:        HSA Parents' Corner
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Ozgur Balsoy
//Company:
//Description:  Online Parental Access to the School Database

package hsa.db;
import hsa.util.Log;

public class dbHashtable
{
  java.util.Hashtable ht;
  statement stmt;
  boolean dataReady = false;

  public dbHashtable(statement _stmt)
  {
    stmt = _stmt;
    ht = new java.util.Hashtable();
    dataReady = next();
  }

  public void init()
  {
    ht.clear();
    put("AUTHOR","Ozgur Balsoy");
  }

  public boolean isReady()
  {
    return dataReady;
  }

  public void close()
  {
    try {
      stmt.close();
    } catch(Exception e) {};
    ht = null;
  }

  public Object get(Object obj)
  {
    Log.debug("(get) obj: '"+obj.toString()+ "'");
    try {
      if(ht.containsKey(obj.toString()))
      {
        Log.debug("(get-ht) value: '"+ht.get(obj).toString()+ "'");
        return ht.get(obj.toString());
      }
      if(stmt != null)
        if(obj instanceof String)
          if(stmt.getResultSet() != null) {
            Object value = stmt.getResultSet().getObject((String)obj);
            put( obj.toString(), value.toString() );
            Log.debug("(get-rs) value: '"+value.toString()+ "'");
            return value;
          }
    } catch(Exception e) {};
    return null;
  }

  public String getString(String obj)
  {
    return (String)get(obj);
  }

  public boolean next()
  {
    try {
      dataReady = stmt.next();
      init();
      return dataReady;
    } catch(Exception e) {
      Log.debug("(dbHashtable-next) Exception. dataReady:"+dataReady);
    };
    return false;
  }

  public Object put(Object key, Object value)
  {
    return ht.put(key, value);
  }

  public void print( java.io.PrintWriter out )
  {
    out.println("<table border=1><tr><th>Keys</th><th>Values</th></tr>");
    for(java.util.Enumeration e=ht.keys(); e.hasMoreElements(); )
    {
      String key = (String)e.nextElement();
      out.println("<tr><td>"+ key+ "</td><td>" + (String)ht.get(key) +"</td></tr>");
    }
    try {
      if(dataReady)
      {
        java.sql.ResultSet rs = stmt.getResultSet();
        java.sql.ResultSetMetaData rsmd = rs.getMetaData();

        int columns = rsmd.getColumnCount();
        for(int i=1; i <= columns; i++)
          out.println("<tr><td>" + (String)rsmd.getColumnName(i) + "</td><td>"
                      + (String)rs.getString(i) + "</td></tr>");
      }
    } catch(Exception e) {};
    out.println("</table>");
  }
}