
//Title:        HSA Parents' Corner
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Ozgur Balsoy
//Company:
//Description:  Online Parental Access to the School Database


package hsa.db;

import hsa.util.*;
import java.io.PrintWriter;
import java.sql.*;
import java.util.*;

public class students
{
  private static String schoolCode = "901";
  private static String schoolYear = "99-00";
  private static String masterTable = "emf"+schoolCode,
                        extendedTable = "ema"+schoolCode,
                        attTable = "atn"+schoolCode,
                        attCodeTable = "cde"+schoolCode,
                        attCmntTable = "atc"+schoolCode;

  private static String fldID = "id_number", fldPwd = "emf_note1";
  private static String spaces = "                                  ";

  public static dbHashtable queryStudent(String idnumber) throws Exception
  {
    return queryStudents("*", "id_number='"+ idnumber +"'", "gradelvl", "id_number");
  }

  public static dbHashtable queryAttendance(String idnumber) throws Exception
  {
    String queryString = "SELECT "+attTable+".id_number, "+attTable+".sch_year, "
         +attTable+".saf_date1, "+attTable+".saf_code, "
         +attCodeTable+".atn_code_t, "+attTable+".saf_cmnt1, "
         +attTable+".saf_tin1, "+attTable+".saf_saf_tout1, "
         +"FROM "+attCodeTable+" INNER JOIN "+attTable+" ON ("
         +attCodeTable+".sch_year = "+attTable+".sch_year) AND ("
         +attCodeTable+".atn_code = "+attTable+".saf_code) "
         +"WHERE ((("+attTable+".id_number)='"+idnumber+"') AND (("
         +attTable+".sch_year)='"+schoolYear+"') AND (("+attTable+".saf_cmnt1)=''))";

    Log.log("(students) attendance: "+ queryString );

    return new dbHashtable( new statement( queryString ));
  }

  public static dbHashtable queryStudents(String projection,
    String condition, String orderBy, String groupBy) throws Exception
  {

    if (projection == null)
      projection = "*";

    String queryString = "select "+ projection +" from "+ masterTable;

    if (condition != null && !condition.equals(""))
      queryString += " where "+ condition;

    if (orderBy != null && !orderBy.equals(""))
      queryString += " order by "+ orderBy;

    if (groupBy != null && !groupBy.equals(""))
      queryString += " group by "+ groupBy;

    Log.log("(students) Query string: "+ queryString );

    return new dbHashtable( new statement( queryString ));
    /*
    statement stmt = new statement(queryString);
    ResultSet rs = stmt.getResultSet();
    ResultSetMetaData rsmd = rs.getMetaData();

    int columns = rsmd.getColumnCount();
    //out.println("Number of columns: " + columns);

    out.println("<table border=1>");
    int j=0;
    while( rs.next() )
    {
      out.println("<tr><td>"+ j + "</td>");
      for(int i=1; i <= columns; i++)
        out.println("<td>" + (String)rs.getString(i) + "</td>");
      out.println("</tr>");
      j++;
    }
    stmt.close();
    out.println("</table>");
    */
  }

  public static boolean authorized(String user, String pass) //, PrintWriter out)
    throws Exception
  {
    try {
      Log.log("Checking authorization for user '"+user+"' with password '"+ pass +"'");
      String s = "select "+ fldPwd +" from "+ masterTable
                +" where "+ fldID +"='"+ user + "'"
                //+" where "+ fldID +"='"+ user + spaces.substring(0,9-user.length()) +"'";
                +" order by "+ fldID +" group by "+ fldID;

      Log.log("Sql statement: '"+ s +"'");
      statement stmt = new statement(s);
      ResultSet rs = stmt.getResultSet();
      if( rs.next() )
      {
        String password = rs.getString(1);
        Log.log("DB password: '"+ password +"'");
        if ( password.trim().equals(pass.trim()) )
          return true;
      } else {
        Log.log("Password check fails.");
      }
    } catch(Exception e) {
      throw e;
    }
    return false;
  }
}