/**
 * Pop3DefaultFolder.java
 *
 * @author Jason Diamond
 * @version 1.1.1
 *
 * <p>Copyright (c) 1998 Jason Diamond</p>
 *
 * <p>sendangels@usa.net<br>
 * http://www.geocities.com/ResearchTriangle/Thinktank/8343/</p>
 *
 */

package injektilo.mail;

import java.io.*;

import javax.mail.*;
import javax.mail.event.*;

import injektilo.net.*;

public class Pop3DefaultFolder
    extends Pop3Folder
{
  public Pop3DefaultFolder(Pop3Store store) {
    super(store, "/");
  }
  
  public Folder getParent()
      throws MessagingException
  {
    return null;
  }
  
  public boolean exists()
      throws MessagingException
  {
    return true;
  }
  
  public Folder[] list(String pattern)
      throws MessagingException
  {
    Folder inbox = new Pop3Inbox(store);
    Folder[] folders = { inbox };
    return folders;
  }
  
  public int getType()
      throws MessagingException
  {
    return HOLDS_FOLDERS;
  }
  
  public Folder getFolder(String name)
      throws MessagingException
  {
    Pop3Folder folder;
    if (name.equalsIgnoreCase("INBOX")) {
      folder = new Pop3Inbox(store);
    } else {
      folder = new Pop3Folder(store, name);
    }
    return folder;
  }
  
  public void open(int mode)
      throws MessagingException
  {
    notifyConnectionListeners(ConnectionEvent.OPENED);
  }
  
  public void close(boolean expunge)
      throws MessagingException
  {
    notifyConnectionListeners(ConnectionEvent.CLOSED);
  }
  
  public boolean isOpen() {
    return true;
  }  
  
  public Message getMessage(int msgnum)
      throws MessagingException
  {
    throw new MessagingException("Pop3DefaultFolder cannot hold messages");
  }
}