/**
 * Pop3Folder.java
 *
 * @author Jason Diamond
 * @version 1.1.1
 *
 * <p>Copyright (c) 1998 Jason Diamond</p>
 *
 * <p>sendangels@usa.net<br>
 * http://www.geocities.com/ResearchTriangle/Thinktank/8343/</p>
 *
 */

package injektilo.mail;

import java.io.*;
import java.util.*;
import javax.mail.*;
import javax.mail.event.*;

import injektilo.net.*;

public class Pop3Folder
    extends Folder
{
  Pop3Store store;
  protected String name;
  
  public Pop3Folder(Pop3Store store, String name) {
    super(store);
    this.store = store;
    this.name = name;
  }
  
  public String getName() {
    return name;
  }
  
  public String getFullName() {
    return name;
  }
  
  public Folder getParent()
      throws MessagingException
  {
    return new Pop3DefaultFolder(store);
  }
  
  public boolean exists()
      throws MessagingException
  {
    return false;
  }
  
  public Folder[] list(String pattern)
      throws MessagingException
  {
    return new Folder[0];
  }
  
  public char getSeparator()
      throws MessagingException
  {
    return '/';
  }
  
  public int getType()
      throws MessagingException
  {
    return 0;
  }
  
  public boolean create(int type)
      throws MessagingException
  {
    throw new MethodNotSupportedException("Pop3Stores cannot create folders");
  }
  
  public boolean hasNewMessages()
      throws MessagingException
  {
    return false;
  }
  
  public Folder getFolder(String name)
      throws MessagingException
  {
    return new Pop3Folder(store, name);
  }
  
  public boolean delete(boolean recurse)
      throws MessagingException
  {
    throw new MethodNotSupportedException("Pop3Folders cannot be deleted");    
  }
  
  public boolean renameTo(Folder f)
      throws MessagingException
  {
    throw new MethodNotSupportedException("Pop3Folders cannot be renamed");
  }
  
  public void open(int mode)
      throws MessagingException
  {
    throw new FolderNotFoundException();    
  }
  
  public void close(boolean expunge)
      throws MessagingException
  {
    throw new FolderNotFoundException();
  }
  
  public boolean isOpen() {
    return false;
  }  
  
  public Flags getPermanentFlags() {
    return new Flags();
  }
  
  public int getMessageCount()
      throws MessagingException
  {
    return 0;
  }
  
  public Message getMessage(int msgnum)
      throws MessagingException
  {
    throw new MessagingException("this Pop3Folder doesn't exist");
  }
  
  public void appendMessages(Message[] msgs)
      throws MessagingException
  {
    throw new MethodNotSupportedException("Pop3Folders cannot append messages");
  }
  
  public Message[] expunge()
      throws MessagingException
  {
    throw new MessagingException("this Pop3Folder doesn't exist");
  }
}