/**
 * Pop3Store.java
 *
 * @author Jason Diamond
 * @version 1.1.1
 *
 * <p>Copyright (c) 1998 Jason Diamond</p>
 *
 * <p>sendangels@usa.net<br>
 * http://www.geocities.com/ResearchTriangle/Thinktank/8343/</p>
 *
 */

package injektilo.mail;

import java.io.*;
import java.net.*;
import javax.mail.*;

import injektilo.net.Pop3Connection;

public class Pop3Store 
    extends Store
{
  Pop3Connection pop3;
  
  public Pop3Store(Session session, URLName url) {
    super(session, url);
    pop3 = new Pop3Connection();
    pop3.setDebug(session.getDebug());
    pop3.setDebugOut(System.out);
    pop3.setAuthentication(Pop3Connection.USER);
  }
  
  protected boolean protocolConnect(
        String host,
        int port,
        String user,
        String pass)
      throws MessagingException
  {
    if (port < 0) {
      port = Pop3Connection.DEFAULT_PORT;
    }
    try {
      if (pop3.open(host, port)) {
        return pop3.authenticate(user, pass);
      }
    } catch (UnknownHostException e) {
      throw new MessagingException("protocolConnect failed", e);
    } catch (IOException e) {
      throw new MessagingException("protocolConnect failed", e);
    }
    return false;
  }
  
  public void close()
      throws MessagingException
  {
    try {
      // pop3.reset();
      pop3.quit();
    } catch (IOException e) {
      throw new MessagingException("close failed", e);
    }
    super.close();
  }
  
  public Folder getDefaultFolder()
      throws MessagingException
  {
    System.out.println("Pop3Store.getDefaultFolder()");
    return new Pop3DefaultFolder(this);
  }
  
  public Folder getFolder(String name)
      throws MessagingException
  {
    System.out.println("Pop3Store.getFolder((String) " + name + ")");
    return new Pop3Folder(this, name);
  }
  
  public Folder getFolder(URLName url)
      throws MessagingException
  {
    System.out.println("Pop3Store.getFolder((URLName) " + url + ")");
    return new Pop3Folder(this, url.getFile());
  }
}