//package cb99ksu;

import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class NewsBoard extends HttpServlet 
    implements SingleThreadModel
{
    String resultsDir;
   String filePath;
 
    public void init(ServletConfig config)
        throws ServletException
    {
        super.init(config);

            //get path to support files
        filePath = config.getInitParameter("FilePath");
        if (filePath == null)
        {
          //default directory if no FilePath init parameter exists
          filePath = "/servers/cgi-http-class/htdoc/cps606fall99-cgi/cb99ksu/";
        }
    }

    /**
     * Write survey results to output file in response to the POSTed
     * form.  Write a "thank you" to the client.     
     */
    public void doPost(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
    
     String currentTopic=""; //user's currently selected topic
    String topic="";
    PrintWriter out=null;

    //get bulletin board topic selected from drop-down list
    currentTopic = req.getParameter("SCHOOLS");
    
    topic = req.getParameter("TOPICS");
    
    //get the name of file containing bulletins for this topic
    String file = filePath + currentTopic + ".txt";
    
    //get path to servlet for use in hyperlinks
    String servletPath = req.getServletPath();

    res.setContentType("text/html"); //html output

    DataInputStream input;


        //Get the response's PrintWriter to return text to the client.
        PrintWriter toClient = res.getWriter();

        try {

			


        
                               
                        // Respond to client with a thank you
                        
                            toClient.println("<HTML>");
      toClient.println("<HEAD><TITLE>" + currentTopic +
        " News Board</TITLE></HEAD>");
      

      toClient.println("<BODY>");
	  toClient.println("<h2>"+currentTopic+"</h2>");

      //View Bulletins

     showBulletins(toClient, currentTopic, file);

      
      toClient.println("</BODY></HTML>");
    }
    catch (Exception e)
    {
      //send stack trace back to client
      sendErrorToClient(toClient, e);
    }
 
        toClient.close();
    }
    private void sendErrorToClient(PrintWriter out, Exception e)
  {
    //send stack trace back to client and to standard out
    StringWriter stringError = new StringWriter();
    PrintWriter printError = new PrintWriter(stringError);
    e.printStackTrace(printError);
    String stackTrace = stringError.toString();

    //send error message to client
    out.println("<HTML><TITLE>Error</TITLE><BODY>");
    out.println("<H1>Servlet Error</H1><H4>Error</H4>" + e +
      "<H4>Stack Trace</H4>" + stackTrace + "</BODY></HTML>");

    //print stack trace to standard out
    System.out.println("Servlet Error: " + stackTrace);
  }

  private void showBulletins(PrintWriter out,
    String currentTopic, String file)
  {
    FileReader fr=null;

    RandomAccessFile br = null ; 
    try
    {

        br = new RandomAccessFile(file,"r" ); 

        String line ;

        out.println("<H2>" + currentTopic + " Bulletin Board</H2>");

	while((line = br.readLine())!=null)
          out.println(line + "<BR>\n");

    }
    catch(FileNotFoundException fnfe)
    {

    out.println("This topic currently doesnt contain any docs :");
	}
    catch (Exception e)
    {
      //send stack trace back to client
      sendErrorToClient(out, e);
    }
    finally
    {
      try
      {
        br.close(); //close buffered reader
      }
      catch (Exception e) {}
      try
      {
        fr.close(); //close file reader
      }
      catch (Exception e) {}
    }
  }

}



