import java.awt.*; 
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
 
public class Paint extends Applet { 
	Label Status; 
	DrawCanvas c; 
	 
    public void init() { 
	setLayout(new BorderLayout()); 
 
	setBackground(Color.gray); 
	setForeground(Color.black); 

	Panel w=new Panel(); 
	w.setLayout(new GridLayout(10, 0)); 
	w.add(new Button("Rect")); 
	w.add(new Button("Circ")); 
	w.add(new Button("Line"));
	w.add(new Button("Round"));
 	w.add(new Button("Text"));
	w.add(new Button("Draw")); 
	w.add(new Button("Redraw")); 
	w.add(new Button("Clear"));
	w.add(new Button("Send"));
 	w.add(new Button("Colors"));
	w.add(new Button("Fonts"));
	w.add(new Button("New"));
	w.add(new Button("Prev"));
	w.add(new Button("Next"));
	

	add("West", w); 
 
	Status=new Label("Status Line"); 
	add("South",Status); 
 
	c=new DrawCanvas(this); 
	c.setBackground(Color.blue); 
	add("Center", c); 
    } 
 
     public void paint(Graphics g) { 
		c.paint(g); 
     } 
 
    public boolean action(Event evt, Object arg) { 
	String s=(String) arg; 
	if (evt.target instanceof Button) { 
		Status.setText(((Button)evt.target).getLabel()); 
		if (s.equals("Draw")) { 
			((Button)evt.target).setLabel("Fill"); 
			c.fill=false; 
		} else if (s.equals("Fill")) { 
			((Button)evt.target).setLabel("Draw"); 
			c.fill=true;
		} else if (s.equals("Send")) {
 			Status.setText("Sending the slide..."); 
			c.sendData();
		} else if (s.equals("Colors")) {
                        c.showColorDialog();
		} else if (s.equals("Fonts")) {
                        c.showFontDialog();
		} else if (s.equals("New")) {
		        c.newSlide();
		} else if (s.equals("Prev")) { 
		        c.showPrevSlide();
		} else if (s.equals("Next")) {
		        c.showNextSlide();
		} else c.setDrawMode(s); 
	} 
	return true; 
    } 
}


class DrawCanvas extends Canvas {

    
    Paint parent;
    String curMode="Rect";
    mPoint curObj;
    public boolean fill=true;
    mSlide objList=null;
    Vector slideList=new Vector(10, 5);
    
    Hashtable colors;
    String    currentColor = "red";
    String    fillColor = "black";
    String    backgroundColor="blue";
    Font      currentFont;
    boolean   interlace=false;
    
    mText     lasttext=null;
    String    script, section, session, title, teacher;
    URL       baseUrl;

	public DrawCanvas(Paint _parent) {
		
		super();
		parent = _parent;
		setBackground(Color.blue);
		setForeground(Color.yellow);

		baseUrl= parent.getDocumentBase();
		script = parent.getParameter("javaTransferScript");
		section= parent.getParameter("scriptSection");
		session= parent.getParameter("lectureCode");
		title  = parent.getParameter("lectureTitle");
		teacher= parent.getParameter("lectureInstructor");

		colors=new Hashtable();
		colors.put("black", 	Color.black);
		colors.put("blue",  	Color.blue);
		colors.put("cyan", 	Color.cyan);
		colors.put("darkGray", 	Color.darkGray);
		colors.put("gray", 	Color.gray);
		colors.put("green", 	Color.green);
		colors.put("lightGray",	Color.lightGray);
		colors.put("magenta", 	Color.magenta);
		colors.put("orange", 	Color.orange);
		colors.put("pink", 	Color.pink);
		colors.put("red", 	Color.red);
		colors.put("white", 	Color.white);
		colors.put("yellow", 	Color.yellow);

		currentFont = new Font("Helvetica", Font.PLAIN, 12);
		slideList.addElement(objList=
		   new mSlide("Slide1", size().width, size().height, "blue"));

	} 

	public void setDrawMode(String s) {
		if(s.equals("Clear")) {
			objList.removeAllElements();
			repaint();
		} else if(s.equals("Redraw")) repaint();
		else curMode=s;
	}

	public void paint(Graphics g) {

	    if (objList != null) {
		g.setColor(getHashedColor(objList.bgColor));
                g.fillRect(0, 0, size().width, size().height);
  
		for(Enumeration e=objList.elements(); e.hasMoreElements() ;) 
		    ((mPoint)e.nextElement()).draw(g);
		  
	      }
	  }

	String constructHeader() {

	        String key;
		Color tempColor;

		String result = "Session " + session + "\n";
		result += "Title " + title + "\nInstructor " + teacher + "\n";
	        for (Enumeration e = colors.keys() ; e.hasMoreElements() ;) {
		    tempColor=(Color)colors.get(key=(String)e.nextElement());
		    result += "Color " + key + " " + 
			Integer.toString(tempColor.getRed()) + " " +
			Integer.toString(tempColor.getGreen()) + " " +
			Integer.toString(tempColor.getBlue()) + "\n";
		  }

		if (slideList != null) 
		  for(Enumeration e=slideList.elements(); e.hasMoreElements() ;) {
		      result += ((mSlide)e.nextElement()).makeString();
		    }
		
		return result;
	}


        public void sendData() {

	        String strReturn = "", strData = "";  
        	Socket sckS = null;
        	try {
         	 sckS = new Socket(baseUrl.getHost(), baseUrl.getPort());
     
         	 DataOutputStream os
            	 	= new DataOutputStream(sckS.getOutputStream());
         	 DataInputStream is
            		= new DataInputStream(sckS.getInputStream());

		 strData = "section=" + section + "&code=" + session + "&information=";
		 strData += constructHeader();
         	 os.writeBytes("POST " + script
            		+ " HTTP/1.0\r\n"
            		+ "Content-type: application/octet-stream\r\n"
            		+ "Content-length: "
            		+ strData.length() + "\r\n\r\n");
         	 os.writeBytes(strData);

         	 String line="";
         	 // get rid of the header.
         	 while (((line = is.readLine()) != null)
			&& !(line.startsWith("Content-type:")));

         	 // save the information
         	 while ((line = is.readLine()) != null)
                	strReturn += line + "\n";

         	 is.close();
         	 os.close();
            
        	} 
		catch (Exception e) {

                	if (sckS != null) {
                	        try { sckS.close(); }   
                        	catch (IOException ex) {}

                	}
        	}
System.out.println("output:\n"+strData);

System.out.println("input:\n"+strReturn);

        }

	public boolean mouseDown(Event e, int x, int y) {		
		
		if (curMode.equals("Rect"))
			curObj=new mRectangle(this, x, y, x, y, currentColor, fillColor);
		if (curMode.equals("Round"))
			curObj=new mRound(this, x, y, x, y, currentColor, fillColor);
		else if (curMode.equals("Circ"))
			curObj=new mCircle(this, x, y, x, y, currentColor, fillColor);
		else if (curMode.equals("Line"))
			curObj=new mLine(this, x, y, x+1, y+1, currentColor, fillColor);
		else if (curMode.equals("Text"));
		return true;
	}

	public boolean mouseDrag(Event e, int x, int y) {

	    if (!curMode.equals("Text")) {
		Graphics g = getGraphics();
		g.setXORMode(Color.black);
		curObj.draw(g);
		curObj.setEnds(x, y);
		curObj.draw(g);
		g.dispose();
	      }
	    return true;
	}

	public boolean mouseUp(Event e, int x, int y) {		

		if (curMode.equals("Text")) {
		    if (lasttext == null) {
		      lasttext=new mText(this, x, y, currentColor);
		      showFontDialog();
		    }
		} else {
		    Graphics g = getGraphics();
		    g.setPaintMode();
		    curObj.setEnds(x, y);
		    curObj.setFill(fill);
		    curObj.draw(g);
		    objList.addElement(curObj);
		    g.dispose();
		  }
		return true;
	}
	
	public Color getHashedColor(String keyColor) {
	        return (Color)colors.get(keyColor);
	}

        public void showColorDialog() {
                Hashtable cu=new Hashtable();
                cu.put("draw color", currentColor);
                cu.put("fill color", fillColor);
                cu.put("background", backgroundColor);
 
                ColorFrame f=new ColorFrame(this, colors, cu);
                f.resize(700, 200);
                f.show();
        }

        public void getNewColors(Hashtable c, Hashtable cu) {

                colors=c;
                currentColor = (String)cu.get("draw color");
                fillColor = (String)cu.get("fill color");
                backgroundColor = (String)cu.get("background");
		objList.changeBG(backgroundColor);
                repaint();
        }

	public void showFontDialog() {
	        
	        FontDialog f=new FontDialog(this, currentFont);
		f.resize(500,300);
		f.show();
	}

        public void getNewFont(Font f, String text, boolean change) {

	    currentFont = f;
	    if (lasttext != null && change) {
		Graphics g = getGraphics();
		g.setPaintMode();
		lasttext.setData(text, f);
		lasttext.draw(g);
		objList.addElement(lasttext);
		g.dispose();
		lasttext=null;
		repaint();
	    }
	    if (!change) lasttext=null;
        }

	public void newSlide() {

	    if (objList != null) {
		String no=String.valueOf(slideList.size()+1);
		objList=new mSlide("Slide"+no, size().width, size().height, backgroundColor);
		slideList.addElement(objList);
	      }
	    repaint();
	  }

	public void showPrevSlide() {

	    if (objList != null) {
		int slideno=slideList.indexOf(objList);
		if (slideno > 0) 
		  objList = (mSlide) slideList.elementAt(slideno-1);
		else objList = (mSlide) slideList.lastElement();
	      }
	    repaint();
	  }

	public void showNextSlide() {

	    if (objList != null) {
		int slideno=slideList.indexOf(objList);
		if (slideno < slideList.size()-1) 
		  objList = (mSlide) slideList.elementAt(slideno+1);
		else objList = (mSlide) slideList.firstElement();
	      }
	    repaint();
	  }
}

class mSlide extends Vector {

    String slideName;
    int width, height;
    String bgColor;

    public mSlide(String name, int w, int h, String bgC) {
	super(15, 10);
	slideName = name;
	width=w;
	height=h;
	bgColor=bgC;
      }

    public void changeBG(String newColor) {
	bgColor=newColor;
      }

    public String makeString() {
	String result= "NewSlide "+slideName+" "+
	  String.valueOf(width)+" "+String.valueOf(height)+" "+bgColor+"\n";

	for(Enumeration e=elements(); e.hasMoreElements() ;) {
	    result += ((mPoint)e.nextElement()).toString() + "\n";
	  }

	result += "EndOf "+slideName+"\n";
	return result;
      }
}

class mPoint {
 
        DrawCanvas parent;
        int x,y,x2,y2;
        boolean fill=false;
        String color, fillcolor;
 
        public mPoint( DrawCanvas _parent, 
		       int _x, int _y, int _x2, int _y2, 
		       String _color, String _fillcolor) {
 
	        parent=_parent;
                x=_x;
                y=_y;
                x2=_x2;
                y2=_y2;
		color=_color;
		fillcolor=_fillcolor;
        };
 
        public void draw(Graphics g) {
                g.setColor(parent.getHashedColor(color));
                g.drawRect(x, y, x2-x, y2-y);
        }
 
        public void setFill(boolean _fill) {
                fill=_fill;
        }
 
        public boolean isIn(int _x, int _y) {
	        if( x==_x && y == _y) return true;
		return false;
        }
 
        public void setEnds(int _x, int _y) {
                x2=_x;
                y2=_y;
        }
 
        public String toString() {
                return "drawLine " +  
                        String.valueOf(x) + " " + String.valueOf(y) + " " +
                        String.valueOf(x) + " " + String.valueOf(y) + " " + color; 
        }
}

class mRectangle extends mPoint {

        public mRectangle( DrawCanvas _parent, 
		       int _x, int _y, int _x2, int _y2, 
		       String _color, String _fillcolor) {

		super(_parent, _x, _y, _x2, _y2, _color, _fillcolor);
	}
 
        public void draw(Graphics g) {
                if (fill) {
                        g.setColor(parent.getHashedColor(fillcolor));
                        g.fillRect(x, y, x2-x, y2-y);
                }
		g.setColor(parent.getHashedColor(color));
                g.drawRect(x, y, x2-x, y2-y);
        }
       
        public boolean isIn(int _x, int _y) {
                Rectangle r=new Rectangle(x, y, x2-x, y2-y);
                return r.inside(_x, _y);
        }
 
        public String toString() {
                String coor = String.valueOf(x) + " " + String.valueOf(y) + " " +
		  String.valueOf(x2) + " " + String.valueOf(y2) + " ";

                if (fill) return "fillRect " + coor + color + " " + fillcolor;
                else return "drawRect " + coor + color;
        }
 
}

class mRound extends mPoint {

        public mRound( DrawCanvas _parent, 
		       int _x, int _y, int _x2, int _y2, 
		       String _color, String _fillcolor) {

		super(_parent, _x, _y, _x2, _y2, _color, _fillcolor);
	}
 
        public void draw(Graphics g) {
                if (fill) {
                        g.setColor(parent.getHashedColor(fillcolor));
                        g.fillRoundRect(x, y, x2-x, y2-y, 100, 50);
                }
		g.setColor(parent.getHashedColor(color));
                g.drawRoundRect(x, y, x2-x, y2-y, 100, 50);
        }
       
        public boolean isIn(int _x, int _y) {
                Rectangle r=new Rectangle(x, y, x2-x, y2-y);
                return r.inside(_x, _y);
        }
 
        public String toString() {
                String coor = String.valueOf(x) + " " + String.valueOf(y) + " " +
		  String.valueOf(x2) + " " + String.valueOf(y2) + " ";
 
                if (fill) return "fillRoundRect " + coor + color + " " + fillcolor;
                else return "drawRoundRect " + coor + color;
        }
 
}

class mLine extends mPoint {

        public mLine( DrawCanvas _parent, 
		       int _x, int _y, int _x2, int _y2, 
		       String _color, String _fillcolor) {

		super(_parent, _x, _y, _x2, _y2, _color, _fillcolor);
	}
 
        public void draw(Graphics g) {
	        g.setColor(parent.getHashedColor(color));
                g.drawLine(x, y, x2, y2);
        }
 
        public String toString() {
 
                return  "drawLine " +
                        String.valueOf(x) + " " + String.valueOf(y) + " " +
                        String.valueOf(x2) + " " + String.valueOf(y2) + " " + color;
        }
}

class mCircle extends mRectangle {
 
        public mCircle( DrawCanvas _parent, 
		       int _x, int _y, int _x2, int _y2, 
		       String _color, String _fillcolor) {

		super(_parent, _x, _y, _x2, _y2, _color, _fillcolor);
	}

        public void draw(Graphics g) {
                if (fill) {
                        g.setColor(parent.getHashedColor(fillcolor));
                        g.fillOval(x, y, x2-x, y2-y);
                }
	        g.setColor(parent.getHashedColor(color));
                g.drawOval(x, y, x2-x, y2-y);
        }
 
        public String toString() {

                String s = "drawOval "; 
                String coor = String.valueOf(x) + " " + String.valueOf(y) + " " +
		  String.valueOf(x2) + " " + String.valueOf(y2) + " ";
 
                if (fill) return "fillOval " + coor + color + " " + fillcolor;
                else return "drawOval " + coor + color;

        }
}

class mText extends mPoint {

    String data;
    Font fontInfo;
    
    public mText( DrawCanvas _parent, 
		       int _x, int _y, 
		       String _color) {

		super(_parent, _x, _y, _x, _y, _color, _color);
		data = "";
		fontInfo = null;

	}

    public void setData(String _data, Font _font) {
	data=_data;
	fontInfo=_font;
    }

    public void draw(Graphics g) {

	g.setFont(fontInfo);
	g.setColor(parent.getHashedColor(color));
	g.drawString(data, x, y);
	
      }

    public String toString() {
	String fontstyle=fontInfo.getName() + " " +
                  	 (fontInfo.isBold() ? "bold" : "not-bold") + " " +
	                 (fontInfo.isItalic() ? "italic" : "not-italic") + " " +
			 String.valueOf(fontInfo.getSize())  ; 

	return  "setFont " + fontstyle + "\n" +
	        "drawString " +
                String.valueOf(x) + " " + String.valueOf(y) + " " + color + " " + data;
        }

}

















































