#!/usr/local/bin/perl
#############################################################################
#  
#   GLOBAL VARIABLES
#
#############################################################################

$sessionDirectory="Sessions";
$sessionInfoFile="info.txt";
$sessionDataFile="slides.txt";
$sessionLastConn="last.txt";
$mainScript="scripts.pl";

$title="<header><title>CSE 791 Term Project - NETBOARD</title></header>\n";
$signature="<hr><address><a href=http://www.cis.syr.edu/~balsoy>Ozgur Balsoy</a></address>\n";

$javaDocumentRoot="/Project";
$CGIdir=$javaDocumentRoot;  # at the moment. 
$javaTransferScript="$CGIdir/$mainScript";  # /$javaDocumentRoot/$javaTransferScr
$javaServerDir="server";
$javaServerCode="Paint.class";
$javaClientDir="client";
$javaClientCode="Client.class";

#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################

&ReadEntry;
&printResults;

#############################################################################
#  
#   SUBROUTINES
#
#############################################################################


sub ReadEntry {
   &Parse(&Read);     # Read arguments passed from fill-out form
   return 1;
}


sub printResults {

&printHeader;

if ($in eq "") { &intro; }

elsif ($in{"section"} eq "title") {
      if ($in{"teach"} eq "yes") { &beginTeach; }
      else { &beginBrowse; }
}

elsif ($in{"section"} eq "teach") {
      if ($in{"code"} eq "") { &errorRepeatTeach; }
      elsif (&prepareSession) { &SendApplet; }
}

elsif ($in{"section"} eq "server") {
      if ($in{"code"} eq "") { print "Error Something's wrong!\n" }
      else { &receiveSlides; }
}

elsif ($in{"section"} eq "browse") {
      if ($in{"code"} eq "") { &errorRepeatBrowse; }
      else { &sendClientApplet; }
}

elsif ($in{"section"} eq "client") {
      if ($in{"code"} eq "") { print "Error Something's wrong!\n"; }
      else { &sendSlides; }
}

#  &Parse(&Read);
#  print join(" - ", %in);
#  return 1;

&printFooter;

}

##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# Returns the magic line which tells WWW that this is an HTML document
sub printHeader {
  print "Content-type: text/html\n\n";
  print "\n";
  print "<html> $title<body>";
}

sub printFooter {
  print "$signature </body></html>\n";
}

# reads the arguments passed from the form
sub Read {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
    }
    return $in;
}

sub Parse {
    $in = $_[0];
    local ($i, $loc, $key, $val);

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
#      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
#      $in{$key} .= $val;
      $in{$key} = $val;
   }
   return 1; 
}


##############################################################################
#
#  Sub programs
#
##############################################################################

# Introduction
# Send a fill out form to find out whether to teach or browse.
sub intro {

print "<h1>CSE 791 Term Project - NETBOARD</h1><hr>\n";
print "Are you going to prepare some class notes, or\n";
print "browse some notes prepared already?\n";

print "<form method=post action=$mainScript>\n";
print "<input type=hidden name=section value=title>\n";
print "<input type=radio NAME=teach value=yes checked> I am going to 
       prepare some class notes.<br>\n";
print "<input type=radio Name=teach value=no> I am going to browse old notes.<br>\n";
print "<input TYPE =submit VALUE = Submit>\n";
print "</form>\n";

}

sub beginTeach {

print "<h2>Please fill out this form and hit the submit button.</h2><hr>\n";
print "<pre>";
print "<form method=post action=$mainScript>";
print "<input type=hidden name=section value=teach>\n";
print "Lecture code : <input name=code size=8>\n";
print "Lecture title: <input name=title size=20>\n";
print "Instructor   : <input name=instructor size=20>\n";
#print "A new one?   : <input type=radio name=new value=yes checked> Yes ";
#print "<input type=radio name=new value=no> No\n";
print "<input TYPE =submit VALUE = Submit>";
print "</pre></form>";

}

sub errorRepeatTeach {

print "<h1>Error!</h1>\n";
print "Please enter at least the lecture code.\n<hr>";
&beginTeach;

}

sub SendApplet {

print "<h1>NETBOARD Connection for session $in{'code'}:$in{'title'}</h1>\n";
print "<applet codebase=$javaServerDir/ code=$javaServerCode ";
print "width=700 height=600>\n";
print "<param name=documentRoot value=\"$javaDocumentRoot\">\n";
print "<param name=javaTransferScript value=\"$javaTransferScript\">\n";
print "<param name=scriptSection value=\"server\">\n";
print "<param name=lectureCode value=\"$in{'code'}\">\n";
print "<param name=lectureTitle value=\"$in{'title'}\">\n";
print "<param name=lectureInstructor value=\"$in{'instructor'}\">\n";
print "</applet><p>\n";
}

sub prepareSession {

$session = $sessionDirectory."/".$in{'code'};
if (-r $sessionDirectory && -w $sessionDirectory) {
   if (-r $session && -w $session) {
       print "<h1>Error</h1><h2>This session already been taught!</h2>\n"; }
   elsif (mkdir($session, 0755)) {
       $date=`date`;
       open (INFO, "> $session/$sessionInfoFile");
       print INFO "code=$in{'code'}&title=$in{'title'}&instructor=$in{'instructor'}&";
       print INFO "host=$ENV{'REMOTE_HOST'}&addr=$ENV{'REMOTE_ADDR'}&";
       print INFO "server=$ENV{'SERVER_NAME'}&date=$date";
       close(INFO);
       return 1;
   } else { print "<h1>Error</h1><h2>Can't create a session directory!</h2>\n"; }
} elsif (mkdir($sessionDirectory, 0755)) {
       return &prepareSession;   
} else { print "<h1>Error</h1><h2>Can't create the session directory!</h2>\n"; }
return 0;
}

sub checkSession {

$session = $_[0];
if (-r $sessionDirectory && -w $sessionDirectory) {
   if (-r $session && -w $session) { return 1; }
}
return 0;
} # checkSession

sub receiveSlides {

$session = $sessionDirectory."/".$in{'code'};
if (&checkSession($session)) {
   if (open(DATA, "> $session/$sessionDataFile")) {
      print DATA $in{'information'};
      close(DATA);
      if (open(LAST, "> $session/$sessionLastConn")) {
         print LAST `date`;
         close(LAST);
      }
      print "OK";
   } else { print "not-OK"; }
} else { print "not-OK"; }
} # receiveSlides

sub sendSlides {

$session = $sessionDirectory."/".$in{'code'};
if (&checkSession($session)) {
   if (open(DATA, "$session/$sessionDataFile")) {
      while ($line=<DATA>) {
        chop($line);
	print "$line\n";
      }
      close(DATA);
   } else { print "Error not-OK"; }
} else { print "Error not-OK"; }
} # sendSlides

sub beginBrowse {

print "<h2>Please enter your name, choose a lecture to browse,\n";
print " and hit the submit button.</h2><hr>\n";
print "<form method=post action=$mainScript>";
print "<input type=hidden name=section value=browse>\n";
print "Your name: <input name=name size=20>\n";
print "<p><table border=1 cellspacing=0 cellpadding=5>";
print "<th></th><th>Course</th><th>Course Title</th><th>Instructor</th>";
print "<th>Instructor's Machine</th><th>Beginning Date</th>";
print "<th>Last Connection</th></tr>\n";

if (opendir(LECTS, $sessionDirectory)) {
   foreach $session (sort readdir(LECTS)) {
      if (($session eq ".") || ($session eq "..")) { next; }
      if (open(INFO, "$sessionDirectory/$session/$sessionInfoFile" )) {
         $data=<INFO>;
	 chop($data);
	 close(INFO);
	 &Parse($data);
	 print "<tr><td><input type=radio name=code value=$in{'code'}></td>\n";
	 print "<td>$session</td><td>$in{'title'}</td><td>$in{'instructor'}</td>\n";
	 if (($host=$in{'host'}) eq "") { $host=$in{'addr'}; }
	 print "<td>$host</td><td>$in{'date'}</td>";
	 if (open(LAST, "$sessionDirectory/$session/$sessionLastConn")) {
            $date=<LAST>;
	    chop($date);
	    close(LAST);
	    print "<td>$date</td>";
	 } else { print "<td>No info.</td>"; }
	 print "</tr>\n\n";
      } else { print "<tr><td colspan=6>Can't reach $session information.</td></tr>\n"; }
  }
} else { print "<tr><td colspan=6>Can't reach the sessions.</td></tr>\n"; }

print "</table><hr>";
print "<input TYPE =submit VALUE = Submit>";
print "</form>";

}

sub errorRepeatBrowse {

print "<h1>Error!</h1>\n";
print "Please choose one of the course(s).\n<hr>";
&beginBrowse;

}

sub sendClientApplet {

print "<h1>NETBOARD Connection for session $in{'code'}</h1>\n";
print "<applet codebase=$javaClientDir/ code=$javaClientCode ";
print "width=700 height=600>\n";
print "<param name=documentRoot value=\"$javaDocumentRoot\">\n";
print "<param name=javaTransferScript value=\"$javaTransferScript\">\n";
print "<param name=scriptSection value=\"client\">\n";
print "<param name=lectureCode value=\"$in{'code'}\">\n";
print "<param name=autoStart value=\"no\">\n";
print "</applet><p>\n";
}
