// ::::::::::::::
// Paint.java
// ::::::::::::::

// Developed by Mehmet Sen. Spring 1996
// Ported to Java 1.1 by Ozgur Balsoy. Fall 1997
// Networking capabilities added by Ozgur Balsoy

import java.awt.*; 
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import com.sun.java.swing.*;
import com.sun.java.swing.plaf.*;
//import com.sun.java.swing.basic.*;
 
public class Paint 
     extends JApplet 
  implements ActionListener // must overwrite actionPerformed() method
{ 
  JLabel Status; 
  DrawCanvas c; 
  
  public void init() { 

    // Force SwingApplet to come up in the System L&F
    String laf = UIManager.getSystemLookAndFeelClassName();
    try {
      UIManager.setLookAndFeel(laf);
      // If you want the Cross Platform L&F instead, comment out the above line and
      // uncomment the following:
      // UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    } catch (UnsupportedLookAndFeelException exc) {
      System.err.println("Warning: UnsupportedLookAndFeel: " + laf);
    } catch (Exception exc) {
      System.err.println("Error loading " + laf + ": " + exc);
    }
    
    getContentPane().setLayout(new BorderLayout()); 
    
    //setBackground(Color.gray); 
    //setForeground(Color.black); 
    
    Toolbar t = new Toolbar(this);
    // Disabling floating
    //ToolBarUI ui = t.getUI();
    //if (ui instanceof BasicToolBarUI)
    // ((BasicToolBarUI)ui).setFloatable (false);
    
    getContentPane().add(BorderLayout.NORTH, t);
    
    Status=new JLabel("Status Line");
    JPanel p=new JPanel();
    p.setBackground(Color.gray);
    p.add(Status);
    getContentPane().add(BorderLayout.SOUTH,p);
    
    c=new DrawCanvas(this);
    c.setBackground(Color.blue);
    getContentPane().add(BorderLayout.CENTER, c);
  } 
  
  //public void paint(Graphics g) { 
  //  c.paint(g); 
  //} 
 
  public void actionPerformed(ActionEvent e) {
    String s = e.getActionCommand();
    
    // We want to change the label of the button,
    // but getSource function returns an Object type object.
    // By type casting, we use it as if it is a button object.
    // Actually, it is a button, but getSource returns it 
    // as an Object type object.
    // Note: We cannot use type casting if we are not sure 
    // that the returning object is a button. In this case, 
    // it is safe to use the following code:
    // if (e.getSource() instanceof Button) {
    //		Button b=(Button)e.getSource();
    //		...
    JButton b=(JButton)e.getSource();
    
    Status.setText(s);
    if (s.equals("Draw")) {
      b.setText("Fill");
      c.fill=false;
    } else if (s.equals("Fill")) {
      b.setText("Draw");
      c.fill=true;
    } else if (s.equals("Send")) {
      Status.setText("Sending the slide..."); 
      c.sendData();
    } else if (s.equals("Colors")) {
      c.showColorDialog();
    } else if (s.equals("Fonts")) {
      c.showFontDialog();
    } else if (s.equals("New")) {
      c.newSlide();
    } else if (s.equals("Prev")) { 
      c.showPrevSlide();
    } else if (s.equals("Next")) {
      c.showNextSlide();
    } else c.setDrawMode(s); 
  }
}


















































