//
// snarfapp.java - 
// Version - 1.0
// 3/23/96 - 1:44:34am
// 
//
// zpb_begin Revisions 
// zpb_end 

import java.awt.*;
import java.util.*;
import java.applet.Applet;
import LogFontLayout;  // Fixed position layout based on font size

// zpb_begin UserImports 
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
// Grabbed from Doug Aberdeen who grabbed it from the Alpha-3 release
import Document;
import Tag;
import TagRef;
import Parser;
import Snarf; // The actual snarfer
// zpb_end 

// zpb_begin AppSecurityManager 
// Override SecurityManager so getImage() will work
import java.io.FileDescriptor;
class EmptySecurityManager extends SecurityManager {
	public void checkCreateClassLoader() {}
	public void checkAccess(Thread g) {}
	public void checkAccess(ThreadGroup g) {}
	public void checkExit(int status) {}
	public void checkExec(String cmd) {}
	public void checkLink(String lib) {}
	public void checkRead(FileDescriptor fd) {}
	public void checkRead(String file) {}
	public void checkRead(String file, Object context) {}
	public void checkWrite(FileDescriptor fd) {}
	public void checkWrite(String file) {}
	public void checkDelete(String file) {}
	public void checkConnect(String host, int port) {}
	public void checkConnect(String host, int port, Object context) {}
	public void checkListen(int port) {}
	public void checkAccept(String host, int port) {}
	public void checkPropertiesAccess() {}
	public void checkPropertyAccess(String key) {}
	public void checkPropertyAccess(String key, String def) {}
	public boolean checkTopLevelWindow(Object window) {return true;}
	public void checkPackageAccess(String pkg) {}
	public void checkPackageDefinition(String pkg) {}
	public void checkSetFactory() {}
}
// zpb_end 


public
class snarfapp extends Frame {

	private static Applet applet;
	TextField pRootEdit, pSnarfDirEdit;
	TextArea pInfoEdit;
	Label pStatic1, pStatic2, pStatic3, pStatic4, pStatic5, pStatic6, pStatic7;
	Button pSnarfBtn, pInfoBtn;
	Checkbox pGetImgCBox;

	Dimension initialSize;
	Point initialLocation;
	// zpb_begin MainUserVars 
	// zpb_end 

	public
	snarfapp(Applet app, String title) {
		super(title);
		applet = app;

		// zpb_begin MainConstructor_1 
		// zpb_end 

		setBackground(Color.lightGray);
		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pStatic1 = new Label("1. The root HTML doc is");
		add("24 26 82 13", pStatic1);
		pRootEdit = new TextField("http://www.");
		add("113 26 187 12", pRootEdit);
		pSnarfBtn = new Button("Snarf It!");
		add("110 75 57 18", pSnarfBtn);
		pStatic2 = new Label("Snarf: The HTML grabbing utility ... snarfing in 4 easy steps!");
		pStatic2.setAlignment(Label.CENTER);
		add("24 5 221 13", pStatic2);
		pInfoEdit = new TextArea("");
		add("24 99 275 163", pInfoEdit);
		pInfoEdit.setEditable(false);
		pStatic3 = new Label("2. The (local) directory for the files snarfed is");
		add("24 44 177 13", pStatic3);
		pSnarfDirEdit = new TextField("snarfed");
		add("215 45 85 12", pSnarfDirEdit);
		pGetImgCBox = new Checkbox("if we want to snarf the images too!");
		add("74 59 124 13", pGetImgCBox);
		pStatic4 = new Label("3. Choose");
		add("25 62 34 10", pStatic4);
		pStatic5 = new Label("4. And now we can ...");
		add("25 77 71 10", pStatic5);
		pStatic6 = new Label("(c) Paralogic Corporation 1996");
		pStatic6.setAlignment(Label.RIGHT);
		add("188 73 112 10", pStatic6);
		pStatic7 = new Label("http://www.webpage.com");
		pStatic7.setAlignment(Label.RIGHT);
		add("188 85 112 10", pStatic7);
		pInfoBtn = new Button("Info!");
		add("268 5 32 12", pInfoBtn);
		// zpb_begin MainConstructor_2 
		// zpb_end 

		// Size and Position in logical units
		initialSize = new Dimension(341, 286);
		initialLocation = lfLayout.du(15, 28);
		
		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin MainConstructor_3 
		// zpb_end 
	}

	public Dimension minimumSize() {
		
		// zpb_begin MainMinimumSize 
		// zpb_end 

		return initialSize; // Let layout manager size Window using logical units
	}

	public boolean handleEvent(Event e) {
		if (e.target == pRootEdit && e.id == Event.GOT_FOCUS) {
			// zpb_begin MainRootEditGotFocus 
			// zpb_end 
			return false;
		}
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin MainDestroy 
			// zpb_end 
			System.exit(0);
			return true;
		}

		// zpb_begin MainHandleEvent 
		// zpb_end 

		return super.handleEvent(e);
	}

	public boolean action(Event evt, Object obj) {
		if (evt.target instanceof MenuItem) {
			String label = (String)obj;

			return true;
		}

		if (evt.target == pSnarfBtn) {
			// zpb_begin MainSnarfBtnClicked 
                          Snarf s = new Snarf(
                            pRootEdit.getText(), pInfoEdit,
                            pSnarfDirEdit.getText(),
                            pGetImgCBox.getState());
                          s.Flatten();
                          
                          pInfoEdit.appendText("Snarfed " +
                            Snarf.ResetVisitedURLs() + " files!\n\n");
			// zpb_end 
		}
		else if (evt.target == pGetImgCBox) {
			// zpb_begin MainGetImgCBoxClicked 
			// zpb_end 
		}
		else if (evt.target == pInfoBtn) {
			helpdialog dHelpDialog= new helpdialog(applet, this, "About Snarf", true);
			// zpb_begin MainInfoBtnClickedShow 
			// zpb_end 
			dHelpDialog.show();
			// zpb_begin MainInfoBtnClicked 
			// zpb_end 
		}

		// zpb_begin MainAction 
		// zpb_end 

		return true;
	}

	public static void main(String args[]) {
		
		// zpb_begin AppMain 
		// zpb_end 

		// zpb_begin AppSecurityManager_2 
		// Override SecurityManager so getImage() will work
		System.setSecurityManager(new EmptySecurityManager());
		// zpb_end 

		snarfapp f = new snarfapp(null, "Applet Browser Frame");
		f.show();

		// zpb_begin AppMain_2 
		// zpb_end 
	}

	// zpb_begin MainUserMethods 
	// zpb_end 
}


class helpdialog extends Dialog {

	private static Applet applet;
	TextArea pAboutText, pHelpEdit;
	Label pStatic1;
	Button pOK;

	Dimension initialSize;
	Point initialLocation;
	// zpb_begin HelpDialogUserVars 
	// zpb_end 

	helpdialog(Applet app, Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		applet = app;
		setResizable(false);

		// zpb_begin HelpDialogConstructor_1 
		// zpb_end 

		LogFontLayout lfLayout = new LogFontLayout(this);
		setLayout(lfLayout);

		pOK = new Button("OK");
		add("83 119 35 17", pOK);
		pAboutText = new TextArea("See readme.txt or email vijay@webpage.com");
		add("21 61 159 31", pAboutText);
		pAboutText.setEditable(false);
		pStatic1 = new Label("(c) Paralogic Corporation 1996");
		add("22 102 159 15", pStatic1);
		pHelpEdit = new TextArea("Documentation? You're kidding!");
		add("21 14 159 31", pHelpEdit);
		pHelpEdit.setEditable(false);
		// zpb_begin HelpDialogConstructor_2 
		// zpb_end 

		// Size and Position in logical units
		initialSize = new Dimension(201, 140);
		initialLocation = lfLayout.du(15, 28);
		
		pack();
		move(initialLocation.x, initialLocation.y);

		// zpb_begin HelpDialogConstructor_3 
		// zpb_end 
	}

	public Dimension minimumSize() {
		
		// zpb_begin HelpDialogMinimumSize 
		// zpb_end 

		return initialSize; // Let layout manager size Window using logical units
	}

	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			// zpb_begin HelpDialogDestroy 
			// zpb_end 
			dispose();
			return true;
		}

		// zpb_begin HelpDialogHandleEvent 
		// zpb_end 

		return super.handleEvent(e);
	}

	public boolean action(Event evt, Object obj) {
		if (evt.target == pOK) {
			// zpb_begin HelpDialogOKClicked 
			// zpb_end 
			dispose();
			return true;
		}

		// zpb_begin HelpDialogAction 
		// zpb_end 

		return true;
	}


	// zpb_begin HelpDialogUserMethods 
	// zpb_end 
}

// zpb_begin UserClasses 
// zpb_end 
